<script setup lang="ts">
import { onMounted } from 'vue'
import { nextTick, ref } from 'vue'

import type { User } from '@/types/User'

import type { VForm } from 'vuetify/components'

const users = ref<User[]>([])

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Email',
    value: 'email',
    key: 'email'
  },
  {
    title: 'Name',
    value: 'name',
    key: 'name'
  },
  {
    title: 'Gender',
    value: 'gender',
    key: 'gender'
  },
  {
    title: 'Roles',
    key: 'roles',
    value: (item: any | User) => item.roles.join(', ')
  },
  { key: 'actions', sortable: false }
]
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
let lastId = 5
const initialUser: User = {
  id: -1,
  email: '',
  password: '',
  name: '',
  gender: 'Male',
  roles: ['Staff']
}

const editedUser = ref<User>(JSON.parse(JSON.stringify(initialUser)))
function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}

let editedIndex = -1
function deleteItemConfirm() {
  if (editedIndex > -1) {
    users.value.splice(editedIndex, 1)
    closeDelete()
  }
}

function editItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}

// function deleteItem(item: User) {
//   editedIndex = users.value.indexOf(item)
//   editedUser.value = Object.assign({}, item)
//   dialogDelete.value = true
//   editedIndex = -1
// }
function deleteItem(item: User) {
  const index = users.value.findIndex((user) => user.id === item.id)

  if (index !== -1) {
    dialogDelete.value = true
    editedIndex = index
  }
}

function initialize() {
  users.value = [
    {
      id: 1,
      email: 'Paweena@gmail.com',
      password: 'Paweena_1234',
      name: 'Paweena Chinasri',
      gender: 'Female',
      roles: ['Manager']
    },
    {
      id: 2,
      email: 'Warissara@gmail.com',
      password: 'Warissara_1234',
      name: 'Warissara Kanjana',
      gender: 'Female',
      roles: ['Staff']
    },
    {
      id: 3,
      email: 'Pitchayaporn@gmail.com',
      password: 'Pitchayaporn_1234',
      name: 'Pitchayaporn Tawornwong',
      gender: 'Female',
      roles: ['Staff']
    },
    {
      id: 4,
      email: 'Phattharapron@gmail.com',
      password: 'Phattharapron_1234',
      name: 'Phattharapron Tancharoen',
      gender: 'Female',
      roles: ['Staff']
    }
  ]
}
onMounted(() => {
  initialize()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    users.value.push(editedUser.value)
  }
  closeDialog()
}

function searchUser(name: string) {
  if (name.trim() === '') {
    initialize()
    return
  }

  const foundUsers = users.value.filter((user) =>
    user.name.toLowerCase().includes(name.toLowerCase())
  )
  users.value = foundUsers
}

function validateEmail() {
  const emailRegex = /^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$/
  return emailRegex.test(editedUser.value.email) || 'Invalid email format'
}
function validatePass() {
  const passwordRegex = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[#@$!%*?&_-])[A-Za-z\d#@$!%*?&_-]{8,}$/
  return passwordRegex.test(editedUser.value.password) || 'Invalid password format'
}

const name = ref('')
function onClick() {
  searchUser(name.value)
}
</script>

<template>
  <div class="app-container">
    <v-data-table :headers="headers" :items="users">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(173, 105, 53)">
          <v-toolbar-title>User</v-toolbar-title>
          <v-text-field
            v-model="name"
            density="compact"
            variant="solo"
            label="Search Name"
            append-inner-icon="mdi-magnify"
            single-line
            hide-details
            @click:append-inner="onClick"
            @keyup.enter="onClick()"
          ></v-text-field>

          <v-btn icon="mdi-cached" color="text-black" @click="initialize"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New User
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedUser.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedUser.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required', (v) => validateEmail()]"
                          class="mb-2"
                          clearable
                          label="Email"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                          v-model="editedUser.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required', (v) => validatePass()]"
                          class="mb-2"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                        >
                        </v-text-field>
                        <small>
                          * รหัสผ่านต้องมี 8 ตัวขึ้นไป ตัวพิมพ์เล็ก (a-z) ตัวพิมพ์ใหญ่ (A-Z) ตัวเลข
                          (0-9) และอักขระพิเศษอย่างน้อย 1 ตัว (#@$!%*?&_-) *</small
                        >
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Gender"
                          :items="['Male', 'Female', 'Other']"
                          v-model="editedUser.gender"
                          variant="solo-filled"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="editedUser.roles"
                          :items="[
                            { title: 'Admin', value: 'admin' },
                            { title: 'User', value: 'user' }
                          ]"
                          label="Select roles"
                          multiple
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>* ระบุช่องที่ต้องกรอก</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">คุณแน่ใจหรือไม่ว่าต้องการลบผู้ใช้รายนี้</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="initialize"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
<style scoped>
.app-container {
  position: relative;
  height: 800px;
}

.app-container::before {
  content: '';
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: url('/cafe.png') no-repeat center center fixed;
  background-size: cover;
  opacity: 0.7;
  z-index: -1;
  /* ตั้งค่า z-index เพื่อให้ pseudo-element อยู่หลัง content ภายใน .app-container */
}
</style>
